// Copyright (2013) Jann Horn <jann@thejh.net>
// This code is licensed under the AGPLv3.

#include "common.h"

char *map;

void check_map_name(void) {
  if (map == NULL) senderr("missing query string", false);
  for (char *p = map; *p; p++) {
    if (*p >= 'a' && *p <= 'z') continue;
    if (*p >= 'A' && *p <= 'Z') continue;
    if (*p >= '0' && *p <= '9') continue;
    if (*p == '_') continue;
    senderr("bad map name", false);
  }
}

int main(void) {
  map = getenv("QUERY_STRING");
  check_map_name();
  
  char cmd[4+strlen(map)+1];
  memcpy(cmd, "map ", 4);
  strcpy(cmd+4, map);
  rcon_send(cmd);
  
  puts("Status: 204 changed map"
     "\nX-Frame-Options: DENY"
     "\n");
  exit(0);
}