// Copyright (2013) Jann Horn <jann@thejh.net>
// This code is licensed under the AGPLv3.

#include "common.h"

static char *maps_url;
static char *maps_dir;

int print_map(struct dirent *dent, void *data) {
  if (!ends_with(dent->d_name, ".png")) return 0;
  
  size_t dent_name_len = strlen(dent->d_name);
  char name_nopng[dent_name_len-4+1];
  memcpyn(name_nopng, dent->d_name, dent_name_len-4);
  
  printf("    <div class=\"map\">"
       "\n      <a href=\"loadmap?%s\">"
       "\n        <div class=\"mapimg\"><img src=\"%s/%s\"></div>"
       "\n        <div class=\"mapname\">%s</div>"
       "\n      </a>"
       "\n    </div>"
       "\n",
    name_nopng, getcval("maps_url"), dent->d_name, name_nopng
  );
  
  return 0;
}

int main(void) {
  maps_url = getcval("maps_url");
  maps_dir = getcval("maps_dir");
  
  puts("Status: 200 graphical listing coming up..."
     "\nContent-Type: text/html;charset=utf8"
     "\nX-Frame-Options: DENY"
     "\n"
     "\n<!DOCTYPE html>"
     "\n<html>"
     "\n  <head>"
     "\n    <title>Quake Control</title>"
     "\n    <style>"
     "\n      .map {float: left; padding: 5px; }"
     "\n    </style>"
     "\n  </head>"
     "\n  <body>");
  
  dir_foreach(maps_dir, print_map, NULL);
  
  puts("  </body>"
     "\n</html>");
  
  exit(0);
}
